#include <cstdio>
#include <string>
#include <iostream>
#include <cctype>
#include <algorithm>
#include <map>
using namespace std;
int main()
{
	string morse[30];
	int i = 0;
	morse[i++] = ".-";
	morse[i++] = "-...";
	morse[i++] = "-.-.";
	morse[i++] = "-..";
	morse[i++] = ".";
	morse[i++] = "..-.";
	morse[i++] = "--.";
	morse[i++] = "....";
	morse[i++] = "..";
	morse[i++] = ".---";
	morse[i++] = "-.-";
	morse[i++] = ".-..";
	morse[i++] = "--";
	morse[i++] = "-.";
	morse[i++] = "---";
	morse[i++] = ".--.";
	morse[i++] = "--.-";
	morse[i++] = ".-.";
	morse[i++] = "...";
	morse[i++] = "-";
	morse[i++] = "..-";
	morse[i++] = "...-";
	morse[i++] = ".--";
	morse[i++] = "-..-";
	morse[i++] = "-.--";
	morse[i++] = "--..";
	morse[26] = "..--";
	morse[27] = ".-.-";
	morse[28] = "---.";
	morse[29] = "----";
	
	map<string, char> encode_map;
	for(int i = 0; i < 26; ++i)
	{
		encode_map[morse[i]] = i + 'A';
	}
	encode_map[morse[26]] = '_';
	encode_map[morse[27]] = ',';
	encode_map[morse[28]] = '.';
	encode_map[morse[29]] = '?';
	string line;
	getline(cin, line);
	while(!cin.eof())
	{
		int lengths[1000];
		string encoded = "";
		for(i = 0; i < line.length(); ++i)
		{
			if(isalnum(line[i]))
			{
				lengths[i] = morse[line[i] - 'A'].length();
				encoded += morse[line[i] - 'A'];
				//cout << line[i] << " " << morse[line[i] - 'A'] << " " << lengths[i] << endl;
			}
			else
			{
				string code;
				switch(line[i])
				{
					case '_':
						code = morse[26];
						break;
					case ',':
						code = morse[27];
						break;
					case '.':
						code += morse[28];
						break;
					default:
						code += morse[29];
						break;
				}
				encoded += code;
				lengths[i] = code.length();
				//cout << line[i] << " " << code << " " << lengths[i] << endl;
			}

			//reverse(lengths, lengths + line.length());
		}
		int j = 0;
		string res;
		/*for(i = 0; i < line.length(); ++i)
		{
			//cout << lengths[i] << " ,";
		}*/
		//cout << endl;
		for(i = line.length() - 1; i >= 0; --i)
		{

			string morse_char = encoded.substr(j, lengths[i]);
			//cout << "i " << i << " j " << j << " length " << lengths[i] << endl << " morse " << morse_char << endl;
			j += lengths[i];
			res += encode_map[morse_char];
		}
		cout << res << endl;
			getline(cin, line);
	}
	return 0;
}
